     <!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Task 23B.40</title>

     <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="task23B.40.css">

</head>

<body>
     <div class="container-fluid picture-cover">
     </div>
     <div class="container">
          <div class="row">
               <div class="col-5">
                    <div class="row">
                         <div class="col-12">
                              <h4>Thông tin của bạn</h4>
                         </div>
                    </div>
                    <div class="row form-group">
                         <div class="col-4">
                              <label>Username</label>
                         </div>
                          <div class="row col-8">
                             <input id = "inp-user-name" class="form-control" type="text">
                         </div>
                    </div>
                    <div class="row form-group">
                         <div class="col-4">
                              <label>Firstname</label>
                         </div>
                          <div class="row col-8">
                              <input id = "inp-first-name" class="form-control" type="text">
                         </div>
                    </div>
                    <div class="row form-group">
                         <div class="col-4">
                              <label>Lastname</label>
                         </div>
                          <div class="row col-8">
                              <input id = "inp-last-name" class="form-control" type="text">
                         </div>
                    </div>
               </div>
               <div class="col-4 text-center">
                    <div class="row form-group">
                         <div class="col-12">
                              <button onclick="onBtnNemClick()" id="btn-dice" class="btn btn-success button-width w-75">Ném</button>
                         </div>    
                    </div>
                    <div class="row form-group">
                         <div class="col-12">
                              <img id="img-dice" class="img-thumbnail" src="dice.png">
                         </div>    
                    </div>
                    <div class="row form-group">
                         <div class="col-12">
                              <p id="p-notification-dice">Chúc mừng</p>
                         </div>    
                    </div>
               </div>
               <div class="col-3  text-center">
                    <div class="row form-group">
                         <div class="col-12">
                              <p>Voucher</p>
                              <p id="p-voucher-id">No ID</p>
                              <p id="p-voucher-percent">0%</p>
                         </div>
                    </div>
                    <div class="row form-group">
                         <div class="col-12">
                              <img id="img-present" class="img-thumbnail" src="xe-may.jpg">
                         </div>
                    </div>
               </div>
          </div>
          <div class="row text-center form-group">
              <div class="col-12"> 
                <button  id="btn-dice-history" class="btn btn-danger button-width w-25" onclick="onBtnDiceHistory()">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
              </div>
          </div>
          <div class="row ">
               <div class="col-12">     
                    <table id="history-placeholder-table" class="table table-striped table-hover border">
                         <tr>
                              <th>Lượt</th>
                              <th>Dice</th>
                         </tr>
                         <tr>
                              <td>1</td>
                              <td>2</td>
                         </tr>
                         <tr>
                              <td>2</td>
                              <td>6</td>
                         </tr>
                         <tr>
                              <td>3</td>
                              <td>4</td>
                         </tr>
                         <tr>
                              <td>4</td>
                              <td>5</td>
                         </tr>
                         <tr>
                              <td>5</td>
                              <td>4</td>
                         </tr>
                    </table>
               </div>
          </div>
     </div>
</body>
<script>
     /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
     const gREQUEST_STATUS_OK = 200;
     const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
     const vBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
     const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";

     const gCOL_COUNT = 0;
     const gCOL_DICE = 1;
     const gCOL_ID = 0;
     const gCOL_PHAN_TRAM_GIAM_GIA = 1;
     const gCOL_GHI_CHU = 2;
     const gCOL_NGAY_CAP_NHAT = 3;
     const gCOL_NGAY_TAO = 4;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    //hàm xử lý khi ấn nút ném 
    function onBtnNemClick(){
          //tạo đối tượng để truyền dữ liệu giữa các bước 
          var vUserObj = {
               username: "", 
               firstname:"", 
               lastname:"",
          }

          //Bước 1: thu thập dữ liệu
          thuThapDuLieu(vUserObj);

          //Bước 2: Kiểm tra dữ liệu 
          var vCheckUser = kiemTraDuLieu(vUserObj);
          if(vCheckUser){
               var vXmlHttpDice = new XMLHttpRequest();
               //Bước 3: gọi API
               callAPIServiceDice(vXmlHttpDice, vUserObj);
               vXmlHttpDice.onreadystatechange = function(){
                    if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                         //bước 4: xử lý reponse trả về từ sever
                         processReponse(vXmlHttpDice);
                    }
               }
          }

    }

    //hàm xử lý khi Dice history được click
    function onBtnDiceHistory(){
     var vUserObj = {
          username:"", 
          firstname:"",
          lastname:""
     };

     var vXmlHttp = new XMLHttpRequest();
     thuThapDuLieu(vUserObj);

     getAPIDiceHistory(vUserObj, vXmlHttp);

     var vCheck = kiemTraDuLieu(vUserObj);
     if(vCheck){
          vXmlHttp.onreadystatechange=function(){
                if(vXmlHttp.readyState==gREQUEST_READY_STATUS_FINISH_AND_OK && vXmlHttp.status==gREQUEST_STATUS_OK){
                    hienThiLichSuTungXucXac(vXmlHttp);
                }
            }
     }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    //Hàm thu thập dữ liệu 
    function thuThapDuLieu(paramUserObj){
          var vInputUserName = document.getElementById("inp-user-name");
          var vInputFirstName = document.getElementById("inp-first-name");
          var vInputLastName = document.getElementById("inp-last-name");

          paramUserObj.username = vInputUserName.value.trim();
          paramUserObj.firstname = vInputFirstName.value.trim();
          paramUserObj.lastname = vInputLastName.value.trim();

    }

    //hàm kiểm tra dữ liệu 
    function kiemTraDuLieu(paramUserObj){
     if(paramUserObj.username == ""){
          alert("Vui lòng nhập Username!");
          return false;
     }
     if(paramUserObj.firstname == ""){
          alert("Vui lòng nhập Firstname!");
          return false;
     }
     if(paramUserObj.lastname == ""){
          alert("Vui lòng nhập Lastname!");
          return false;
     }
     return true;
    }

    //hàm gọi API
    function callAPIServiceDice(paramXmlHttpDice, paramUserObj){
          paramXmlHttpDice.open("POST", vBASE_URL + "/dice", true);
          paramXmlHttpDice.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
          paramXmlHttpDice.send(JSON.stringify(paramUserObj)); //chuyển json object sang string 
     }

     //hàm xử lý reponse trả về thành công 
     function processReponse(paramXmlHttpDice){
          "use strict"
          console.log(paramXmlHttpDice.responseText);

          //chuyển JSON sang Object
          var vReponseToObject = JSON.parse(paramXmlHttpDice.responseText);
          console.log(vReponseToObject);

          //lấy kểt quả Dice
          var vDiceReady = vReponseToObject.dice;
          console.log("Dice result: " + vDiceReady);

          //gọi hàm hiển thị dice
          changeDice(vDiceReady);

          //gọi hàm hiển thị lời nhắn 
          changeNotification(vDiceReady);

          //gọi hàm hiển thị voucher
          hienThiVoucher(vReponseToObject);

          //gọi hàm hiện ảnh quà
          changeGift(vReponseToObject);
     }
     
     //hàm hiển thị dice
     function changeDice(paramDice){
          "use strict"
          var vImgDice = document.getElementById("img-dice");
          switch(paramDice){
               case 1: 
                    vImgDice.src = "1.png";
                    break;
               case 2: 
                    vImgDice.src = "2.png";
                    break;
               case 3: 
                    vImgDice.src = "3.png";
                    break;
               case 4: 
                    vImgDice.src = "4.png";
                    break;
               case 5: 
                    vImgDice.src = "5.png";
                    break;
               default: 
                    vImgDice.src = "6.png";
                    
          }
     }

     //hàm hiển thị lời nhắn 
     function changeNotification(paramDice){
          "use strict"
          var vNotification = document.getElementById("p-notification-dice");
          if(paramDice < 4){
               vNotification.innerHTML = ("Chúc bạn may mắn lần sau!");
          }
          else 
          {
               vNotification.innerHTML = ("Chúc mừng bạn hãy chơi thêm lần nữa!!!");    
          }
     }

     //hàm hiển thị voucher
     function hienThiVoucher(paramResponeVoucher){
          "use strict"
          var vPVoucherId = document.getElementById("p-voucher-id");
          var vPVoucherPercent = document.getElementById("p-voucher-percent");

          if(paramResponeVoucher.voucher != null){
               vPVoucherId.innerHTML = paramResponeVoucher.voucher.maVoucher;
               vPVoucherPercent.innerHTML = paramResponeVoucher.voucher.phanTramGiamGia + "%";
          }
          else
          {
               vPVoucherId.innerHTML = "";
               vPVoucherPercent.innerHTML = "";
          }

     }

     //hàm hiện ảnh phần thưởng
     function changeGift(paramResponePrize){
          var vImgPresent = document.getElementById("img-present");
          var vTenPhanThuong = paramResponePrize.prize;
          switch(vTenPhanThuong){
               case "Mũ":
                    vImgPresent.src = "hat.jpg";
                    break;
               case "Áo":
                    vImgPresent.src = "t-shirt.jpg";
                    break;
               case "Xe máy":
                    vImgPresent.src = "xe-may.jpg";
                    break;
               case "Ô tô":
                    vImgPresent.src = "car.jpg";
                    break;
               default:
                    vImgPresent.src = "no-present.jpg";           
          }
     }

     //hàm gọi API để lấy lịch sử tung xúc xắc 
     function getAPIDiceHistory(paramUserObj, paramXmlHttp){
          paramXmlHttp.open("GET", gBASE_URL + "/dice-history?username=" + paramUser.userName, true);
          paramXmlHttp.send();
     }

     //hàm hiển thị lịch sử tung xúc xắc
     function hienThiLichSuTungXucXac(paramXmlHttp){
          var vDiceHistoryObj = JSON.parse(paramXmlHttp.responseText);
          var vTableDice = document.getElementById("history-placeholder-table");
          var vTableBody=vTableDice.getElementsByTagName("tbody")[0];

          for(var bI=0;bI<vDiceHistoryObj.dices.length;bI++){

               var vNewRow=vTableBody.insertRow(gEND_OF_ROW_COL);
               var vCellCount=vNewRow.insertCell(gCOL_COUNT);
               var vCellDice=vNewRow.insertCell(gCOL_DICE);

               vCellCount.innerHTML=bI+1;
               vCellDice.innerHTML= vDiceHistoryObj.dices[bI];
          }
     }
</script>
</html>